package main

import (
	"fmt"
	"log"
	"net/http"

	"github.com/gorilla/mux"
)

var userColl = make(map[string]string)

func main() {
	userColl["userTokenForA"] = "a"
	userColl["userTokenForB"] = "b"

	handleRequests()
}

func handleRequests() {
	router := mux.NewRouter().StrictSlash(true)
	router.PathPrefix("/public").Handler(http.StripPrefix("/public/", http.FileServer(http.Dir("./public/"))))
	router.Use(authenticate)
	router.HandleFunc("/todo", todoHandler).Methods("GET")
	log.Fatal(http.ListenAndServe(":4010", router))
}

func authenticate(next http.Handler) http.Handler {
	return http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		log.Println("=====", r.RequestURI, "=====")
		token := r.Header.Get("authentication")
		user := userColl[token]
		fmt.Println("token:", token, "user:", user)
		if user != "" {
			w.Header().Set("user", user)
		}
		next.ServeHTTP(w, r)
	})
}

func todoHandler(w http.ResponseWriter, r *http.Request) {}
